using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;

using System.Diagnostics;

using System.Net;

namespace GMDL
{
    public partial class GetWikiImg : Form
    {
        WebClient wc;
        string user_agent;

        public GetWikiImg()
        {
            InitializeComponent();

            wc = new WebClient();
            user_agent = "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6";
        }

        public GetWikiImg(WebClient WC, string UserAgent)
        {
            InitializeComponent();

            wc = WC;
            user_agent = UserAgent;
        }

        private void GetWikiImg_Load(object sender, EventArgs e)
        {
            Dir.Text = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\\Images";
        }

        private void GetImages_Click(object sender, EventArgs e)
        {
            GetImages.Enabled = false;
            Application.DoEvents();

            Messages.Items.Clear();
            Errors.Items.Clear();
            Msg("Starting . . .");
            
            DirectoryInfo dir = new DirectoryInfo(Dir.Text);
            if (dir.Exists == false)
                dir.Create();
            if (CopyDef.Checked)
            {
                foreach (FileInfo file in new DirectoryInfo("Wikipedia").GetFiles())
                {
                    if (file.Name.StartsWith(".") == false)
                    {
                        if (new FileInfo(dir.FullName + "\\" + file.Name).Exists == false)
                        {
                            file.CopyTo(dir.FullName + "\\" + file.Name);
                        }
                    }
                }
            }

            string url = WB.Url.AbsoluteUri;

            DataTable pages = new DataTable();
            pages.Columns.Add("url");
            pages.Rows.Add(new object[] {url});
            images = 0;
            i_e = 0;
            p_e = 0;
            GetImg(url, Int32.Parse(Depth.Text), pages, dir);

            Msg("");
            string msg = "Done " + pages.Rows.Count.ToString() + " pages (with " + p_e.ToString() + " errors), " + images.ToString() + " images (with " + i_e.ToString() + " errors)";
            Msg(msg);
            MessageBox.Show(msg);

            Progress.Text = "";
            GetImages.Enabled = true;
        }

        int images;
        int i_e;
        int p_e;

        private void GetImg(string url, int depth, DataTable pages, DirectoryInfo dir)
        {
            Msg("");
            Msg(url);
            string page = "";
            try
            {
                if (wc.Headers.Count == 0)
                    wc.Headers.Add("User-Agent", user_agent);
                page = wc.DownloadString(url);
            }
            catch
            {
                Msg("error (page): " + url);
                Err("error (page): " + url);
                p_e++;
            }
            if (page != "")
            {
                int start = page.IndexOf("\"/wiki/" + IntImage.Text + ":");
                while (start != -1)
                {
                    start = page.IndexOf(":", start) + 1;
                    int end = page.IndexOf("\"", start);
                    string name = page.Substring(start, end - start);
                    name = name.Replace("%28", "(").Replace("%29", ")");
                    //name = new Uri("http://a.com/" + name).ToString(); // unicode, (, etc.
                    //name = name.Substring(13, name.Length - 13);
                    name = name.Replace("_", "%20");
                    if (name.ToLower().EndsWith(".ogg") == false && page.IndexOf("src=\"", start) != -1 && page.IndexOf("src=\"", start) < page.IndexOf("</a>", start)) // for non-images
                    {
                        if (name.ToLower().EndsWith(".gif") == false && name.ToLower().EndsWith(".jpeg") == false && name.ToLower().EndsWith(".jpg") == false && name.ToLower().EndsWith(".png") == false && name.ToLower().EndsWith(".svg") == false)
                        {
                            Err("EXT? " + name);
                            Err(" @ " + url);
                        }

                        start = page.IndexOf("src=\"", start);
                        start = page.IndexOf("\"", start) + 1;
                        end = page.IndexOf("\"", start);
                        string img = page.Substring(start, end - start);
                        if (img.StartsWith("http://"))
                        {
                            if (name.Length > 250)
                            {
                                Err("LEN? " + name.Length.ToString() + " " + name);
                                Err(" @ " + url);
                            }
                            else
                            {
                                if (new FileInfo(dir.FullName + "\\" + name).Exists == false)
                                {
                                    Msg(name);
                                    if (wc.Headers.Count == 0)
                                        wc.Headers.Add("User-Agent", user_agent);
                                    try
                                    {
                                        wc.DownloadFile(img, dir.FullName + "\\" + name);
                                    }
                                    catch
                                    {
                                        Msg("error (img): " + img);
                                        Err("error (img): " + img);
                                        Err(" @ " + url);
                                        i_e++;
                                    }
                                    images++;
                                }
                                if (LeadingSpaceCopy.Checked && new FileInfo(dir.FullName + "\\" + name).Exists && new FileInfo(dir.FullName + "\\%20" + name).Exists == false)
                                {
                                    new FileInfo(dir.FullName + "\\" + name).CopyTo(dir.FullName + "\\%20" + name);
                                }
                            }
                        }
                    }
                    start = page.IndexOf("\"/wiki/" + IntImage.Text + ":", start);
                }

                if (depth > 0)
                {
                    int page_tot = 0;
                    int page_num = 0;
                    if (depth.ToString() == Depth.Text)
                    {
                        DataTable pagesCOPY = pages.Copy();
                        start = page.IndexOf("<a href=\"/wiki/");
                        while (start != -1)
                        {
                            start = page.IndexOf("i/", start) + 2;
                            int end = page.IndexOf("\"", start);
                            string url2 = page.Substring(start, end - start);
                            if (url2.IndexOf(IntImage.Text + ":") == -1)
                            {
                                url2 = url.Substring(0, url.IndexOf("i/") + 2) + url2;
                                if (pagesCOPY.Select("url = '" + url2 + "'").Length == 0)
                                {
                                    page_tot++;
                                    pagesCOPY.Rows.Add(new object[] { url2 });
                                }
                            }
                            start = page.IndexOf("<a href=\"/wiki/", start);
                        }
                    }

                    start = page.IndexOf("<a href=\"/wiki/");
                    while (start != -1)
                    {
                        start = page.IndexOf("i/", start) + 2;
                        int end = page.IndexOf("\"", start);
                        string url2 = page.Substring(start, end - start);
                        if (url2.IndexOf(IntImage.Text + ":") == -1)
                        {
                            url2 = url.Substring(0, url.IndexOf("i/") + 2) + url2;
                            if (pages.Select("url = '" + url2 + "'").Length == 0)
                            {
                                pages.Rows.Add(new object[] { url2 });
                                if (page_num >= Int32.Parse(From.Text))
                                    GetImg(url2, depth - 1, pages, dir);
                                if (page_tot != 0)
                                {
                                    page_num++;
                                    Progress.Text = ((100 * page_num) / page_tot).ToString() + "% (" + page_num.ToString() + "/" + page_tot.ToString() + ") " + pages.Rows.Count.ToString() + "-" + p_e.ToString() + "p " + images.ToString() + "-" + i_e.ToString() + "i";
                                    Application.DoEvents();
                                }
                            }
                        }
                        start = page.IndexOf("<a href=\"/wiki/", start);
                    }
                }
            }
        }

        private void Msg(string msg)
        {
            if (Messages.Items.Count > 250)
            {
                Messages.Items.Clear();
                Msg("*** Message log reset at 250 ***");
                Msg("");
            }

            Messages.Items.Add(msg);
            Messages.SelectedIndex = Messages.Items.Count - 1;
            Application.DoEvents();
        }

        private void Err(string err)
        {
            Errors.Items.Add(err);
            Errors.SelectedIndex = Errors.Items.Count - 1;
            Application.DoEvents();
        }

        private void d0_Click(object sender, EventArgs e)
        {
            Depth.Text = "0";
        }

        private void d1_Click(object sender, EventArgs e)
        {
            Depth.Text = "1";
        }

        private void d2_Click(object sender, EventArgs e)
        {
            Depth.Text = "2";
            MessageBox.Show("A depth of 2 will download a lot of pages (3 levels), and take a long time\n\n(use for lists of lists)");
        }

        private void d3_Click(object sender, EventArgs e)
        {
            //Depth.Text = "3";
            MessageBox.Show("A depth of 3 is disabled (4 levels), change the source if you want to set it\n\n(use for lists of lists of lists)");
        }

        private void Fix_Click(object sender, EventArgs e)
        {
            DirectoryInfo dir = new DirectoryInfo(Dir.Text);
            int len = dir.GetFiles().Length;
            int count = 0;
            int done = 0;
            foreach (FileInfo file in dir.GetFiles())
            {
                if (file.Name.IndexOf("%28") != -1 || file.Name.IndexOf("%29") != -1)
                {
                    file.MoveTo(file.FullName.Replace("%28", "(").Replace("%29", ")"));
                    done++;
                }
                count++;
                Progress.Text = ((100 * count) / len).ToString() + "% (" + count.ToString() + "/" + len.ToString() + ") " + done.ToString();
                Application.DoEvents();
            }

            MessageBox.Show("Done: " + Progress.Text);
            Progress.Text = "";
        }

        private void Errors_DoubleClick(object sender, EventArgs e)
        {
            if (Errors.SelectedIndex >= 0)
                Progress.Text = Errors.SelectedItem.ToString();
        }

        private void Advanced_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Fix.Visible = true;
        }
    }
}